diff --git a/jit/jit-rules-x86-64.c b/jit/jit-rules-x86-64.c
index 155d201..aae357a 100644
--- a/jit/jit-rules-x86-64.c
+++ b/jit/jit-rules-x86-64.c
@@ -152,17 +152,38 @@ typedef struct
 } _jit_va_list;
 
 /* Registers used for INTEGER arguments */
+#ifdef WIN64
+static int _jit_word_arg_regs[] = {
+								   X86_64_REG_RCX, X86_64_REG_RDX,
+								   X86_64_REG_R8, X86_64_REG_R9};
+#define _jit_num_word_regs	4
+#define ARGREG1 X86_64_RCX
+#define ARGREG2 X86_64_RDX
+#define ARGREG3 X86_64_R8
+#define ARGREG4 X86_64_R9
+#else
 static int _jit_word_arg_regs[] = {X86_64_REG_RDI, X86_64_REG_RSI,
 								   X86_64_REG_RDX, X86_64_REG_RCX,
 								   X86_64_REG_R8, X86_64_REG_R9};
 #define _jit_num_word_regs	6
+#define ARGREG1 X86_64_RDI
+#define ARGREG2 X86_64_RSI
+#define ARGREG3 X86_64_RDX
+#define ARGREG4 X86_64_RCX
+#endif
 
 /* Registers used for float arguments */
+#ifdef WIN64
+static int _jit_float_arg_regs[] = {X86_64_REG_XMM0, X86_64_REG_XMM1,
+									X86_64_REG_XMM2, X86_64_REG_XMM3};
+#define _jit_num_float_regs	4
+#else
 static int _jit_float_arg_regs[] = {X86_64_REG_XMM0, X86_64_REG_XMM1,
 									X86_64_REG_XMM2, X86_64_REG_XMM3,
 									X86_64_REG_XMM4, X86_64_REG_XMM5,
 									X86_64_REG_XMM6, X86_64_REG_XMM7};
 #define _jit_num_float_regs	8
+#endif
 
 /* Registers used for returning INTEGER values */
 static int _jit_word_return_regs[] = {X86_64_REG_RAX, X86_64_REG_RDX};
@@ -205,12 +226,21 @@ _jit_init_backend(void)
 
 	/* register class with all call clobbered registers */
 	x86_64_creg = _jit_regclass_create(
+#ifdef WIN64
+		"creg", JIT_REG_WORD | JIT_REG_LONG, 7,
+		X86_64_REG_RAX, X86_64_REG_RCX,
+		X86_64_REG_RDX, X86_64_REG_R8,
+		X86_64_REG_R9 , X86_64_REG_R10,
+		X86_64_REG_R11
+#else
 		"creg", JIT_REG_WORD | JIT_REG_LONG, 9,
 		X86_64_REG_RAX, X86_64_REG_RCX,
-		X86_64_REG_RDX, X86_64_REG_RSI,
-		X86_64_REG_RDI, X86_64_REG_R8,
-		X86_64_REG_R9, X86_64_REG_R10,
-		X86_64_REG_R11);
+		X86_64_REG_RDX, X86_64_REG_RSI, 
+    X86_64_REG_RDI, X86_64_REG_R8,
+		X86_64_REG_R9 , X86_64_REG_R10,
+		X86_64_REG_R11
+#endif
+    );
 
 	/* r egister class for divisors */
 	x86_64_dreg = _jit_regclass_create(
@@ -288,37 +318,13 @@ _jit_xmm1_reg_imm_size_float32(jit_gencode_t gen, unsigned char **inst_ptr,
 			       X86_64_XMM1_OP opc, int reg,
 			       jit_float32 *float32_value)
 {
-	void *ptr;
-	jit_nint offset;
-	unsigned char *inst;
+	jit_int* int_value = (jit_int*)float32_value;
+	unsigned char *inst = *inst_ptr;
 
-	inst = *inst_ptr;
-	ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float32));
-	if(!ptr)
-	{
-		return 0;
-	}
-	jit_memcpy(ptr, float32_value, sizeof(jit_float32));
+	x86_64_push_imm(inst, *int_value);
+	x86_64_xmm1_reg_membase(inst, opc, reg, X86_64_RSP, 0, 0);
+	x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 
-	offset = (jit_nint)ptr - ((jit_nint)inst + (reg > 7 ? 9 : 8));
-	if((offset >= jit_min_int) && (offset <= jit_max_int))
-	{
-		/* We can use RIP relative addressing here */
-		x86_64_xmm1_reg_membase(inst, opc, reg,
-									 X86_64_RIP, offset, 0);
-	}
-	else if(((jit_nint)ptr >= jit_min_int) &&
-			((jit_nint)ptr <= jit_max_int))
-	{
-		/* We can use absolute addressing */
-		x86_64_xmm1_reg_mem(inst, opc, reg, (jit_nint)ptr, 0);
-	}
-	else
-	{
-		/* We have to use an extra general register */
-		TODO();
-		return 0;
-	}
 	*inst_ptr = inst;
 	return 1;
 }
@@ -331,37 +337,14 @@ _jit_xmm1_reg_imm_size_float64(jit_gencode_t gen, unsigned char **inst_ptr,
 			       X86_64_XMM1_OP opc, int reg,
 			       jit_float64 *float64_value)
 {
-	void *ptr;
-	jit_nint offset;
-	unsigned char *inst;
+	jit_int* int_value = (jit_int*)float64_value;
+	unsigned char *inst = *inst_ptr;
 
-	inst = *inst_ptr;
-	ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float64));
-	if(!ptr)
-	{
-		return 0;
-	}
-	jit_memcpy(ptr, float64_value, sizeof(jit_float64));
+	x86_64_push_imm(inst, int_value[0]);
+	x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, int_value[1], 4);
+	x86_64_xmm1_reg_membase(inst, opc, reg, X86_64_RSP, 0, 1);
+	x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 
-	offset = (jit_nint)ptr - ((jit_nint)inst + (reg > 7 ? 9 : 8));
-	if((offset >= jit_min_int) && (offset <= jit_max_int))
-	{
-		/* We can use RIP relative addressing here */
-		x86_64_xmm1_reg_membase(inst, opc, reg,
-									 X86_64_RIP, offset, 1);
-	}
-	else if(((jit_nint)ptr >= jit_min_int) &&
-			((jit_nint)ptr <= jit_max_int))
-	{
-		/* We can use absolute addressing */
-		x86_64_xmm1_reg_mem(inst, opc, reg, (jit_nint)ptr, 1);
-	}
-	else
-	{
-		/* We have to use an extra general register */
-		TODO();
-		return 0;
-	}
 	*inst_ptr = inst;
 	return 1;
 }
@@ -373,39 +356,18 @@ static int
 _jit_plops_reg_imm(jit_gencode_t gen, unsigned char **inst_ptr,
 				   X86_64_XMM_PLOP opc, int reg, void *packed_value)
 {
-	void *ptr;
-	jit_nint offset;
-	unsigned char *inst;
+	jit_int* int_value = (jit_int*)packed_value;
+	unsigned char *inst = *inst_ptr;
 
-	inst = *inst_ptr;
-	ptr = _jit_cache_alloc(&(gen->posn), 16);
-	if(!ptr)
-	{
-		return 0;
-	}
-	jit_memcpy(ptr, packed_value, 16);
+	x86_64_push_imm(inst, int_value[2]);
+	x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, int_value[3], 4);
+	x86_64_push_imm(inst, int_value[0]);
+	x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, int_value[1], 4);
+	x86_64_plops_reg_membase(inst, opc, reg, X86_64_RSP, 0);
+	x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 16, 8);
 
-	/* calculate the offset for membase addressing */
-	offset = (jit_nint)ptr - ((jit_nint)inst + (reg > 7 ? 8 : 7));
-	if((offset >= jit_min_int) && (offset <= jit_max_int))
-	{
-		/* We can use RIP relative addressing here */
-		x86_64_plops_reg_membase(inst, opc, reg, X86_64_RIP, offset);
-		*inst_ptr = inst;
-		return 1;
-	}
-	/* Check if mem addressing can be used */
-	if(((jit_nint)ptr >= jit_min_int) &&
-		((jit_nint)ptr <= jit_max_int))
-	{
-		/* We can use absolute addressing */
-		x86_64_plops_reg_mem(inst, opc, reg, (jit_nint)ptr);
-		*inst_ptr = inst;
-		return 1;
-	}
-	/* We have to use an extra general register */
-	TODO();
-	return 0;
+	*inst_ptr = inst;
+	return 1;
 }
 
 /*
@@ -415,39 +377,18 @@ static int
 _jit_plopd_reg_imm(jit_gencode_t gen, unsigned char **inst_ptr,
 				   X86_64_XMM_PLOP opc, int reg, void *packed_value)
 {
-	void *ptr;
-	jit_nint offset;
-	unsigned char *inst;
+	jit_int* int_value = (jit_int*)packed_value;
+	unsigned char *inst = *inst_ptr;
 
-	inst = *inst_ptr;
-	ptr = _jit_cache_alloc(&(gen->posn), 16);
-	if(!ptr)
-	{
-		return 0;
-	}
-	jit_memcpy(ptr, packed_value, 16);
+	x86_64_push_imm(inst, int_value[2]);
+	x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, int_value[3], 4);
+	x86_64_push_imm(inst, int_value[0]);
+	x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, int_value[1], 4);
+	x86_64_plopd_reg_membase(inst, opc, reg, X86_64_RSP, 0);
+	x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 16, 8);
 
-	/* calculate the offset for membase addressing */
-	offset = (jit_nint)ptr - ((jit_nint)inst + (reg > 7 ? 9 : 8));
-	if((offset >= jit_min_int) && (offset <= jit_max_int))
-	{
-		/* We can use RIP relative addressing here */
-		x86_64_plopd_reg_membase(inst, opc, reg, X86_64_RIP, offset);
-		*inst_ptr = inst;
-		return 1;
-	}
-	/* Check if mem addressing can be used */
-	if(((jit_nint)ptr >= jit_min_int) &&
-		((jit_nint)ptr <= jit_max_int))
-	{
-		/* We can use absolute addressing */
-		x86_64_plopd_reg_mem(inst, opc, reg, (jit_nint)ptr);
-		*inst_ptr = inst;
-		return 1;
-	}
-	/* We have to use an extra general register */
-	TODO();
-	return 0;
+	*inst_ptr = inst;
+	return 1;
 }
 
 /*
@@ -820,7 +761,9 @@ x86_64_call_code(unsigned char *inst, jit_nint func)
 {
 	jit_nint offset;
 
+#ifndef WIN64
 	x86_64_mov_reg_imm_size(inst, X86_64_RAX, 8, 4);
+#endif
 	offset = func - ((jit_nint)inst + 5);
 	if(offset >= jit_min_int && offset <= jit_max_int)
 	{
@@ -1375,60 +1318,19 @@ static unsigned char *
 xmm_cmp_reg_imm(jit_gencode_t gen, unsigned char *inst, int xreg, void *imm,
 		int is_double)
 {
-	int inst_len = 7 + (is_double ? 1 : 0) + (xreg > 7 ? 1 : 0);
-	void *ptr;
-	jit_nint offset;
-
+	jit_int* int_value = (jit_int*)imm;
+	
+	x86_64_push_imm(inst, int_value[0]);
 	if(is_double)
 	{
-		ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float64));
-		if(!ptr)
-		{
-			return 0;
-		}
-		jit_memcpy(ptr, imm, sizeof(jit_float64));
-	}
-	else
-	{
-		ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float32));
-		if(!ptr)
-		{
-			return 0;
-		}
-		jit_memcpy(ptr, imm, sizeof(jit_float32));
-	}
-	offset = (jit_nint)ptr - ((jit_nint)inst + inst_len);
-	if((offset >= jit_min_int) && (offset <= jit_max_int))
-	{
-		/* We can use RIP relative addressing here */
-		if(is_double)
-		{
-			x86_64_ucomisd_reg_membase(inst, xreg, X86_64_RIP, offset);
-		}
-		else
-		{
-			x86_64_ucomiss_reg_membase(inst, xreg, X86_64_RIP, offset);
-		}
-	}
-	else if(((jit_nint)ptr >= jit_min_int) &&
-		((jit_nint)ptr <= jit_max_int))
-	{
-		/* We can use absolute addressing */
-		if(is_double)
-		{
-			x86_64_ucomisd_reg_mem(inst, xreg, (jit_nint)ptr);
-		}
-		else
-		{
-			x86_64_ucomiss_reg_mem(inst, xreg, (jit_nint)ptr);
-		}
+		x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, int_value[1], 4);
+		x86_64_ucomisd_reg_membase(inst, xreg, X86_64_RSP, 0);
 	}
 	else
 	{
-		/* We have to use an extra general register */
-		TODO();
-		return 0;
+		x86_64_ucomiss_reg_membase(inst, xreg, X86_64_RSP, 0);
 	}
+	x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 	return inst;
 }
 
@@ -1701,7 +1603,6 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 {
 	jit_type_t type;
 	int src_reg, other_src_reg;
-	void *ptr;
 	int offset;
 
 	/* Make sure that we have sufficient space */
@@ -1790,7 +1691,7 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 				}
 				else
-				{
+				{					
 					if(float32_value == (jit_float32) 0.0)
 					{
 						x86_fldz(inst);
@@ -1801,28 +1702,16 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 					else
 					{
-						jit_nint offset;
-
-						ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float32));
-						jit_memcpy(ptr, &float32_value, sizeof(float32_value));
-
-						offset = (jit_nint)ptr - ((jit_nint)inst + 6);
-						if((offset >= jit_min_int) && (offset <= jit_max_int))
+						union
 						{
-							/* We can use RIP relative addressing here */
-							x86_64_fld_membase_size(inst, X86_64_RIP, offset, 4);
-						}
-						else if(((jit_nint)ptr >= jit_min_int) &&
-								((jit_nint)ptr <= jit_max_int))
-						{
-							/* We can use absolute addressing */
-							x86_64_fld_mem_size(inst, (jit_nint)ptr, 4);
-						}
-						else
-						{
-							/* We have to use an extra general register */
-							TODO();
-						}
+							jit_float32 float32_value;
+							jit_int int_value;
+						} un;
+
+						un.float32_value = float32_value;
+						x86_64_push_imm(inst, un.int_value);
+						x86_64_fld_membase_size(inst, X86_64_RSP, 0, 4);
+						x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 					}
 				}
 			}
@@ -1870,28 +1759,17 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 					else
 					{
-						jit_nint offset;
-
-						ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_float64));
-						jit_memcpy(ptr, &float64_value, sizeof(float64_value));
-
-						offset = (jit_nint)ptr - ((jit_nint)inst + 6);
-						if((offset >= jit_min_int) && (offset <= jit_max_int))
-						{
-							/* We can use RIP relative addressing here */
-							x86_64_fld_membase_size(inst, X86_64_RIP, offset, 8);
-						}
-						else if(((jit_nint)ptr >= jit_min_int) &&
-								((jit_nint)ptr <= jit_max_int))
-						{
-							/* We can use absolute addressing */
-							x86_64_fld_mem_size(inst, (jit_nint)ptr, 8);
-						}
-						else
+						union
 						{
-							/* We have to use an extra general register */
-							TODO();
-						}
+							jit_float64 float64_value;
+							jit_int int_value[2];
+						} un;
+
+						un.float64_value = float64_value;
+						x86_64_push_imm(inst, un.int_value[0]);
+						x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, un.int_value[1], 4);
+						x86_64_fld_membase_size(inst, X86_64_RSP, 0, 8);
+						x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 					}
 				}
 			}
@@ -1915,29 +1793,17 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 				}
 				else if(IS_XMM_REG(reg) && sizeof(jit_nfloat) == sizeof(jit_float64))
 				{
-					jit_nint offset;
-					int xmm_reg = _jit_reg_info[reg].cpu_reg;
-
-					ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_nfloat));
-					jit_memcpy(ptr, &nfloat_value, sizeof(nfloat_value));
-					offset = (jit_nint)ptr - 
-								((jit_nint)inst + (xmm_reg > 7 ? 9 : 8));
-					if((offset >= jit_min_int) && (offset <= jit_max_int))
-					{
-						/* We can use RIP relative addressing here */
-						x86_64_movsd_reg_membase(inst, xmm_reg, X86_64_RIP, offset);
-					}
-					else if(((jit_nint)ptr >= jit_min_int) &&
-							((jit_nint)ptr <= jit_max_int))
-					{
-						/* We can use absolute addressing */
-						x86_64_movsd_reg_mem(inst, xmm_reg, (jit_nint)ptr);
-					}
-					else
+					union
 					{
-						/* We have to use an extra general register */
-						TODO();
-					}
+						jit_nfloat nfloat_value;
+						jit_int int_value[2];
+					} un;
+
+					un.nfloat_value = nfloat_value;
+					x86_64_push_imm(inst, un.int_value[0]);
+					x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, un.int_value[1], 4);
+					x86_64_movsd_reg_membase(inst, reg, X86_64_RSP, 0);
+					x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 				}
 				else
 				{
@@ -1951,41 +1817,27 @@ _jit_gen_load_value(jit_gencode_t gen, int reg, int other_reg, jit_value_t value
 					}
 					else
 					{
-						jit_nint offset;
-
-						ptr = _jit_cache_alloc(&(gen->posn), sizeof(jit_nfloat));
-						jit_memcpy(ptr, &nfloat_value, sizeof(nfloat_value));
+						union
+						{
+							jit_nfloat nfloat_value;
+							jit_int int_value[3];
+						} un;
 
-						offset = (jit_nint)ptr - ((jit_nint)inst + 6);
-						if((offset >= jit_min_int) && (offset <= jit_max_int))
+						un.nfloat_value = nfloat_value;
+						if(sizeof(jit_nfloat) == sizeof(jit_float64))
 						{
-							/* We can use RIP relative addressing here */
-							if(sizeof(jit_nfloat) == sizeof(jit_float64))
-							{
-								x86_64_fld_membase_size(inst, X86_64_RIP, offset, 8);
-							}
-							else
-							{
-								x86_64_fld_membase_size(inst, X86_64_RIP, offset, 10);
-							}
-						}
-						else if(((jit_nint)ptr >= jit_min_int) &&
-								((jit_nint)ptr <= jit_max_int))
-						{
-							/* We can use absolute addressing */
-							if(sizeof(jit_nfloat) == sizeof(jit_float64))
-							{
-								x86_64_fld_mem_size(inst, (jit_nint)ptr, 8);
-							}
-							else
-							{
-								x86_64_fld_mem_size(inst, (jit_nint)ptr, 10);
-							}
+							x86_64_push_imm(inst, un.int_value[0]);
+							x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, un.int_value[1], 4);
+							x86_64_fld_membase_size(inst, X86_64_RSP, 0, 8);
+							x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 8, 8);
 						}
 						else
 						{
-							/* We have to use an extra general register */
-							TODO();
+							x86_64_push_imm(inst, un.int_value[2]);
+							x86_64_push_imm(inst, un.int_value[0]);
+							x86_64_mov_membase_imm_size(inst, X86_64_RSP, 4, un.int_value[1], 4);
+							x86_64_fld_membase_size(inst, X86_64_RSP, 0, 10);
+							x86_64_alu_reg_imm_size(inst, X86_ADD, X86_64_RSP, 16, 8);
 						}
 					}
 				}
@@ -2387,6 +2239,25 @@ _jit_gen_get_elf_info(jit_elf_info_t *info)
 	info->abi_version = 0;
 }
 
+int
+_jit_count_regs_saved(jit_gencode_t gen)
+{
+	int regs_saved = 0;
+	int reg;
+	
+	/* Get the number of registers we preserves */
+	for(reg = 0; reg < 14; ++reg)
+	{
+		if(jit_reg_is_used(gen->touched, reg) &&
+		   (_jit_reg_info[reg].flags & JIT_REG_CALL_USED) == 0)
+		{
+			++regs_saved;
+		}
+	}
+	
+	return 	regs_saved;
+}
+
 void *
 _jit_gen_prolog(jit_gencode_t gen, jit_function_t func, void *buf)
 {
@@ -2394,7 +2265,7 @@ _jit_gen_prolog(jit_gencode_t gen, jit_function_t func, void *buf)
 	unsigned char *inst = prolog;
 	int reg;
 	int frame_size = 0;
-	int regs_to_save = 0;
+	int regs_to_save = _jit_count_regs_saved(gen);	
 
 	/* Push ebp onto the stack */
 	x86_64_push_reg_size(inst, X86_64_RBP, 8);
@@ -2409,16 +2280,6 @@ _jit_gen_prolog(jit_gencode_t gen, jit_function_t func, void *buf)
 		frame_size = (func->builder->frame_size + 0x7) & ~0x7;
 	}
 
-	/* Get the number of registers we need to preserve */
-	for(reg = 0; reg < 14; ++reg)
-	{
-		if(jit_reg_is_used(gen->touched, reg) &&
-		   (_jit_reg_info[reg].flags & JIT_REG_CALL_USED) == 0)
-		{
-			++regs_to_save;
-		}
-	}
-
 	/* add the register save area to the initial frame size */
 	frame_size += (regs_to_save << 3);
 
@@ -2529,17 +2390,7 @@ _jit_gen_epilog(jit_gencode_t gen, jit_function_t func)
 	if(gen->stack_changed)
 	{
 		int frame_size = func->builder->frame_size;
-		int regs_saved = 0;
-
-		/* Get the number of registers we preserves */
-		for(reg = 0; reg < 14; ++reg)
-		{
-			if(jit_reg_is_used(gen->touched, reg) &&
-			   (_jit_reg_info[reg].flags & JIT_REG_CALL_USED) == 0)
-			{
-				++regs_saved;
-			}
-		}
+		int regs_saved = _jit_count_regs_saved(gen);
 
 		/* add the register save area to the initial frame size */
 		frame_size += (regs_saved << 3);
@@ -2547,7 +2398,7 @@ _jit_gen_epilog(jit_gencode_t gen, jit_function_t func)
 		/* Make sure that the framesize is a multiple of 16 bytes */
 		/* so that the final RSP will be alligned on a 16byte boundary. */
 		frame_size = (frame_size + 0xf) & ~0xf;
-
+		
 		current_offset = -frame_size;
 
 		for(reg = 0; reg <= 14; ++reg)
@@ -2698,52 +2549,52 @@ memory_copy(jit_gencode_t gen, unsigned char *inst,
 			int dreg, jit_nint doffset,
 			int sreg, jit_nint soffset, jit_nint size)
 {
-	if(dreg == X86_64_RDI)
+	if(dreg == ARGREG1)
 	{
-		if(sreg != X86_64_RSI)
+		if(sreg != ARGREG2)
 		{
-			x86_64_mov_reg_reg_size(inst, X86_64_RSI, sreg, 8);
+			x86_64_mov_reg_reg_size(inst, ARGREG2, sreg, 8);
 		}
 	}
-	else if(dreg == X86_64_RSI)
+	else if(dreg == ARGREG2)
 	{
-		if(sreg == X86_64_RDI)
+		if(sreg == ARGREG1)
 		{
 			/* The registers are swapped so we need a temporary register */
-			x86_64_mov_reg_reg_size(inst, X86_64_RCX, X86_64_RSI, 8);
-			x86_64_mov_reg_reg_size(inst, X86_64_RSI, X86_64_RDI, 8);
-			x86_64_mov_reg_reg_size(inst, X86_64_RDI, X86_64_RCX, 8);
+			x86_64_mov_reg_reg_size(inst, X86_64_RCX, ARGREG2, 8);
+			x86_64_mov_reg_reg_size(inst, ARGREG2, ARGREG1, 8);
+			x86_64_mov_reg_reg_size(inst, ARGREG1, X86_64_RCX, 8);
 		}
 		else
 		{
-			x86_64_mov_reg_reg_size(inst, X86_64_RDI, X86_64_RSI, 8);
-			if(sreg != X86_64_RSI)
+			x86_64_mov_reg_reg_size(inst, ARGREG1, ARGREG2, 8);
+			if(sreg != ARGREG2)
 			{
-				x86_64_mov_reg_reg_size(inst, X86_64_RSI, sreg, 8);
+				x86_64_mov_reg_reg_size(inst, ARGREG2, sreg, 8);
 			}
 		}
 	}
 	else
 	{
-		x86_64_mov_reg_reg_size(inst, X86_64_RSI, sreg, 8);
-		x86_64_mov_reg_reg_size(inst, X86_64_RDI, dreg, 8);
+		x86_64_mov_reg_reg_size(inst, ARGREG2, sreg, 8);
+		x86_64_mov_reg_reg_size(inst, ARGREG1, dreg, 8);
 	}
 	/* Move the size to argument register 3 now */
 	if((size > 0) && (size <= jit_max_uint))
 	{
-		x86_64_mov_reg_imm_size(inst, X86_64_RDX, size, 4);
+		x86_64_mov_reg_imm_size(inst, ARGREG3, size, 4);
 	}
 	else
 	{
-		x86_64_mov_reg_imm_size(inst, X86_64_RDX, size, 8);
+		x86_64_mov_reg_imm_size(inst, ARGREG3, size, 8);
 	}
 	if(soffset != 0)
 	{
-		x86_64_add_reg_imm_size(inst, X86_64_RSI, soffset, 8);
+		x86_64_add_reg_imm_size(inst, ARGREG2, soffset, 8);
 	}
 	if(doffset != 0)
 	{
-		x86_64_add_reg_imm_size(inst, X86_64_RDI, doffset, 8);
+		x86_64_add_reg_imm_size(inst, ARGREG1, doffset, 8);
 	}
 	inst = x86_64_call_code(inst, (jit_nint)jit_memcpy);
 	return inst;
@@ -3580,6 +3431,9 @@ _jit_init_args(int abi, jit_param_passing_t *passing)
 	passing->word_regs = _jit_word_arg_regs;
 	passing->max_float_regs = _jit_num_float_regs;
 	passing->float_regs = _jit_float_arg_regs;
+#ifdef WIN64
+	passing->stack_size += 32;
+#endif
 }
 
 int
diff --git a/jit/jit-rules-x86-64.h b/jit/jit-rules-x86-64.h
index 37b896d..ca18b8d 100644
--- a/jit/jit-rules-x86-64.h
+++ b/jit/jit-rules-x86-64.h
@@ -36,49 +36,95 @@ extern	"C" {
 	(JIT_REG_FLOAT32 | JIT_REG_FLOAT64)
 #define JIT_REG_X86_64_GENERAL	\
 	(JIT_REG_WORD | JIT_REG_LONG)
+#ifdef WIN64
 #define	JIT_REG_INFO	\
-	{"rax", 0, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"rcx", 1, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"rdx", 2, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"rbx", 3, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
-	{"rsi", 6, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"rdi", 7, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"r8",  8, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"r9",  9, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"r10", 10, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"r11", 11, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
-	{"r12", 12, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
-	{"r13", 13, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
-	{"r14", 14, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
-	{"r15", 15, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
-	{"rbp", 5, -1, JIT_REG_FRAME | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
-	{"rsp", 4, -1, JIT_REG_STACK_PTR | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
-	{"xmm0", 0, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm1", 1, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm2", 2, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm3", 3, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm4", 4, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm5", 5, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm6", 6, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm7", 7, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm8", 8, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm9", 9, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm10", 10, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm11", 11, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm12", 12, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm13", 13, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm14", 14, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"xmm15", 15, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
-	{"st0", 0, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st1", 1, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st2", 2, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st3", 3, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st4", 4, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st5", 5, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st6", 6, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
-	{"st7", 7, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK},
+	{"rax", NULL, 0, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rcx", "intarg1", 1, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rdx", "intarg2", 2, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rbx", NULL, 3, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"rsi", NULL, 6, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"rdi", NULL, 7, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r8",  "intarg3", 8, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r9",  "intarg4", 9, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r10", NULL, 10, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r11", NULL, 11, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r12", NULL, 12, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r13", NULL, 13, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r14", NULL, 14, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r15", NULL, 15, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"rbp", NULL, 5, -1, JIT_REG_FRAME | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
+	{"rsp", NULL, 4, -1, JIT_REG_STACK_PTR | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
+	{"xmm0", "xmmarg1", 0, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm1", "xmmarg2", 1, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm2", "xmmarg3", 2, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm3", "xmmarg4", 3, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm4", NULL, 4, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm5", NULL, 5, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm6", NULL, 6, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm7", NULL, 7, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm8", NULL, 8, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm9", NULL, 9, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm10", NULL, 10, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm11", NULL, 11, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm12", NULL, 12, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm13", NULL, 13, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm14", NULL, 14, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm15", NULL, 15, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"st0", NULL, 0, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st1", NULL, 1, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st2", NULL, 2, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st3", NULL, 3, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st4", NULL, 4, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st5", NULL, 5, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st6", NULL, 6, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st7", NULL, 7, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK},
+#define	JIT_NUM_REGS		40
+#define	JIT_NUM_GLOBAL_REGS	7
+#else
+#define	JIT_REG_INFO	\
+	{"rax", NULL, 0, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rcx", "intarg4", 1, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rdx", "intarg3", 2, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rbx", NULL, 3, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"rsi", "intarg2", 6, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"rdi", "intarg1", 7, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r8",  "intarg5", 8, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r9",  "intarg6", 9, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r10", NULL, 10, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r11", NULL, 11, -1, JIT_REG_X86_64_GENERAL | JIT_REG_CALL_USED}, \
+	{"r12", NULL, 12, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r13", NULL, 13, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r14", NULL, 14, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"r15", NULL, 15, -1, JIT_REG_X86_64_GENERAL | JIT_REG_GLOBAL}, \
+	{"rbp", NULL, 5, -1, JIT_REG_FRAME | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
+	{"rsp", NULL, 4, -1, JIT_REG_STACK_PTR | JIT_REG_FIXED | JIT_REG_CALL_USED}, \
+	{"xmm0", "xmmarg1", 0, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm1", "xmmarg2", 1, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm2", "xmmarg3", 2, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm3", "xmmarg4", 3, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm4", "xmmarg5", 4, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm5", "xmmarg6", 5, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm6", "xmmarg7", 6, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm7", "xmmarg8", 7, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm8", NULL, 8, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm9", NULL, 9, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm10", NULL, 10, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm11", NULL, 11, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm12", NULL, 12, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm13", NULL, 13, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm14", NULL, 14, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"xmm15", NULL, 15, -1, JIT_REG_X86_64_XMM | JIT_REG_CALL_USED}, \
+	{"st0", NULL, 0, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st1", NULL, 1, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st2", NULL, 2, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st3", NULL, 3, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st4", NULL, 4, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st5", NULL, 5, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st6", NULL, 6, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK}, \
+	{"st7", NULL, 7, -1, JIT_REG_X86_64_FLOAT | JIT_REG_CALL_USED | JIT_REG_IN_STACK},
 #define	JIT_NUM_REGS		40
 #define	JIT_NUM_GLOBAL_REGS	5
+#endif
 
 #define JIT_REG_STACK		1
 #define JIT_REG_STACK_START	32
